<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="mhp.oee.dao.extend.ReasonCodeAndReasonCodeGroupPOMapper">
  <resultMap id="BaseResultMap" type="mhp.oee.po.extend.ReasonCodeAndReasonCodeGroupPO">
    <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
    <result column="SITE" jdbcType="VARCHAR" property="site" />
    <result column="REASON_CODE" jdbcType="VARCHAR" property="reasonCode" />
    <result column="DESCRIPTION" jdbcType="VARCHAR" property="description" />
    <result column="REASON_CODE_GROUP" jdbcType="VARCHAR" property="reasonCodeGroup" />
    <result column="ENABLED" jdbcType="VARCHAR" property="enabled" />
    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    <association property="reasonCodeGroupPO" column="reasonCodeGroup" javaType="mhp.oee.po.gen.ReasonCodeGroupPO">
        <id column="HANDLE" jdbcType="VARCHAR" property="handle" />
	    <result column="SITE" jdbcType="VARCHAR" property="site" />
	    <result column="REASON_CODE_GROUP" jdbcType="VARCHAR" property="reasonCodeGroup" />
	    <result column="DESCRIPTION_GROUP" jdbcType="VARCHAR" property="description" />
	    <result column="ENABLED" jdbcType="VARCHAR" property="enabled" />
	    <result column="CREATED_DATE_TIME" jdbcType="TIMESTAMP" property="createdDateTime" />
	    <result column="MODIFIED_DATE_TIME" jdbcType="TIMESTAMP" property="modifiedDateTime" />
	    <result column="MODIFIED_USER" jdbcType="VARCHAR" property="modifiedUser" />
    </association>  
  </resultMap>
   <select id="selectReasonCodeAndReasonCodeGroup" resultMap="BaseResultMap">
	SELECT A.*,B.REASON_CODE_GROUP,B.DESCRIPTION AS DESCRIPTION_GROUP 
	FROM REASON_CODE AS A 
	LEFT JOIN REASON_CODE_GROUP AS B
    ON A.REASON_CODE_GROUP = B.REASON_CODE_GROUP AND A.SITE = B.SITE
    WHERE A.SITE= #{site} 
    AND A.REASON_CODE_GROUP = #{reasonCodeGroup} 
    <if test="enabled != null">
    	AND A.ENABLED = #{enabled}
    </if>
    ORDER BY B.REASON_CODE_GROUP, A.REASON_CODE
	<if test="limit != null">
      <if test="offset != null">
        limit ${limit} offset ${offset}
      </if>
      <if test="offset == null">
        limit ${limit}
      </if>
    </if>
  </select>
  <select id="selectReasonCodeAndReasonCodeGroupCount" resultType="java.lang.Integer">
	SELECT COUNT(*)
	FROM REASON_CODE AS A 
	LEFT JOIN REASON_CODE_GROUP AS B
    ON A.REASON_CODE_GROUP = B.REASON_CODE_GROUP AND A.SITE = B.SITE
    WHERE A.SITE= #{site} 
    AND A.REASON_CODE_GROUP = #{reasonCodeGroup} 
    <if test="enabled != null">
    	AND A.ENABLED = #{enabled}
    </if>
  </select>
</mapper>